#!/usr/bin/env ruby
# 
# Checks two things for issues referenced in the `quarantine:` RSpec metadata attribute:
# 
# 1. The issue has at least one label including the quarantine substring
# 2. The issue is in the opened state.
# 
require "gitlab"

# TODO: Fill this up with a list of issues that are listed in a `quarantine:` RSpec metadata
# 
# I got the initial list from searching in VSCode for the `quarantine:` string.
issue_ids = [
  413270,
  462444,
  462445,
  462446,
  426713,
  444899,
  460040,
  446286,
  332078,
  394693,
  403208,
  390310,
  446136,
  468470,
  449075,
  444686,
  456464,
  11057,
  444882,
  341827,
  391611,
  410102,
  461551,
  437680,
  424582,
  446246,
  431776,
  444383,
  444732,
  455603,
  416659,
  375026,
  450035,
  449531,
  343506,
  474086,
  474085,
  338073,
  461171,
  467630,
  439360,
  447505,
  447507,
  356772,
  433350,
  463508,
  297357,
  457794,
  444693,
  463717,
  463718,
  463071,
  463465,
  472965,
  472966,
  450187,
  411332,
  444921,
  438942,
  468476,
  461421,
  448371,
  446187,
  446041,
  446042,
  463198,
  324122,
  446093,
  452322,
  444702,
  325556,
  448411,
  375028,
  469091,
  464681,
  299575,
  338332,
  444982,
  444984,
  408233,
  395802,
  460029,
  451295,
  444621,
  441334,
  351426,
  383970,
  410100,
  391192,
  444850,
  334481,
  408749,
  207973,
  432824,
  455829,
  458723,
  444683,
  343995,
  430713,
  231426,
  446199,
  446203,
  393344,
  420845,
  388728,
  416585,
  471790,
  207951,
  27985,
  391757,
  345229,
  389287,
  27959,
  27991,
  375241,
  267525,
  446195,
  378184,
  435076,
  408560,
  343006,
  444681,
  393518,
  285294,
  27950,
  393331,
  209999,
  447484,
  443415,
  199050,
  196826,
  375024,
  327439,
  410109,
  391239,
  337477,
  224100,
  38277,
  258989,
  268240,
  333793,
  333628,
  408223,
  444512,
  408222,
  391632,
  397040,
  410499,
  448293,
  410496,
  446062,
  446063,
  452347,
  452350,
  409990,
  358845,
  381115,
  448572,
  448573,
  408215,
  409984,
  410129,
  391780,
  415220,
  332317,
  251076,
  446283,
  408387,
  444873,
  444713,
  446111,
  446202,
  444979,
  446174,
  447553,
  454749,
  454333,
  446120,
  446121,
  446122,
  446123,
  444919,
  446141,
  438765,
  451677,
  463861,
  349762,
  451914,
  457548,
  448374,
  463107,
  444712,
  446114,
  446130,
  444710,
  326194,
  448732,
  330335,
  413230,
  444704,
  448693,
  367991,
  439529,
  338671,
  444646,
  446115,
  350868,
  341520,
  444510,
  458136,
  436572,
  444864,
  451377,
  446179,
  446108,
  280554,
  196825,
  217810,
  294047,
  448337,
  437144,
  448376,
  444373,
  462538,
  346542,
  472013,
  444869,
  446272,
  231426
]

issue_ids.each do |issue_id|
  issue = Gitlab.issue('gitlab-org/gitlab', issue_id)
  if issue.state != 'opened'
    puts "https://gitlab.com/gitlab-org/gitlab/-/issues/#{issue_id} is not opened! (state: #{issue.state})"
  end

  next if issue.labels.any? { |label| label.include?('quarantine') }
  puts "https://gitlab.com/gitlab-org/gitlab/-/issues/#{issue_id} does not have a quarantine label!"
end
